<template>
  <el-dialog
    v-loading="loading"
    :title="title"
    :center="true"
    align="left"
    top="18vh"
    width="500px"
    :close-on-click-modal="false"
    :visible.sync="showModelThis"
    element-loading-text="拼命加载中"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0.8)"
    @close="showModelThis = false"
  >
    <el-card style="margin: -20px 0 0 0">
      <el-row :gutter="10">
        <el-col :span="24">
          <el-form
            ref="ruleForm"
            :model="ruleForm"
            status-icon
            :rules="rules"
            label-width="80px"
            class="demo-ruleForm"
          >
            <el-form-item label="名称" prop="name">
              <el-input
                v-model="ruleForm['name']"
                :disabled="id == '007'"
                placeholder="名称"
                maxlength="20"
              />
            </el-form-item>
          </el-form>
        </el-col>
        <el-col :span="24" style="text-align: right">
          <el-button
            v-if="id !== '007'"
            type="primary"
            @click="submitForm"
          >保 存
          </el-button>
          <el-button @click="showModelThis = false">{{
            id == "007" ? "关 闭" : "取 消"
          }}</el-button>
        </el-col>
      </el-row>
    </el-card>
  </el-dialog>
</template>
<script>
import asyncRequest from '@/apis/service/serviceParam/storeStyle'
import resToken from '@/mixins/resToken'

/**
 * @props
 * name 名称
*/
export default {
  name: 'Brand',
  mixins: [resToken],
  props: ['showModel', 'id', 'sitem'],
  data() {
    return {
      loading: false,
      title: '添加场地特色',
      showModelThis: this.showModel,
      select: '1',
      activeOptions: [],
      actionList: [],
      ruleForm: {
        id: '',
        name:""
      },
      rulesThis: this.rules,
      rules: {
        name: [{ required: true, message: '名称不能为空', trigger: 'blur' }]
      }
    }
  },
  watch: {
    showModel: function(val) {
      this.showModelThis = val
      if (val) {
        this.initForm()
      }
    },
    showModelThis(val) {
      if (!val) {
        this.$emit('cancel')
      }
    }
  },
  methods: {
    async initForm() {
      this.loading = true
      const basicTitle = '场地特色'
      let prefix = this.id === '005' ? '修改' : this.id === '002' ? '添加' : ''
      this.title = prefix ? prefix + basicTitle : basicTitle + '详情'
      await this.resetForm()
      this.loading = false
    },
    async resetForm() {
      // 重置
      await this.$nextTick(() => {
        if (this.$refs.ruleForm) {
          this.$refs.ruleForm.resetFields()
          this.$refs.ruleForm.clearValidate()
          const { id, name } = this.sitem
          this.ruleForm = {
            id: id || '',
            name: name || ''
          }
        }
      })
    },
    async submitForm() {
      await this.$refs.ruleForm.validate(async(valid) => {
        if (valid) {
          if (!this.loading) {
            this.loading = true
            const model = JSON.parse(JSON.stringify(this.ruleForm))
            let res = {}
            if (this.id === '002') {
              delete model['id']
              res = await asyncRequest.add(model)
            } else {
              res = await asyncRequest.update(model)
            }
            this.loading = false
            if (res && res.code === 1) {
              const title = this.id === '002' ? '添加成功!' : '修改成功!'
              this.$notify.success({
                title,
                message: ''
              })
              this.showModelThis = false
              // 刷新
              this.$emit('refresh')
            } 
          }
        } else {
          console.log('error submit!!')
          return false
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.brand {
}
</style>
